# Autogenerated wrapper script for ImageMagick_jll for powerpc64le-linux-gnu
export libwand

using Zlib_jll
using libpng_jll
using JpegTurbo_jll
using Libtiff_jll
## Global variables
PATH = ""
LIBPATH = ""
LIBPATH_env = "LD_LIBRARY_PATH"

# Relative path to `libwand`
const libwand_splitpath = ["lib", "libMagickWand-6.Q16.so"]

# This will be filled out by __init__() for all products, as it must be done at runtime
libwand_path = ""

# libwand-specific global declaration
# This will be filled out by __init__()
libwand_handle = C_NULL

# This must be `const` so that we can use it with `ccall()`
const libwand = "libMagickWand-6.Q16.so.6"


"""
Open all libraries
"""
function __init__()
    global artifact_dir = abspath(artifact"ImageMagick")

    # Initialize PATH and LIBPATH environment variable listings
    global PATH_list, LIBPATH_list
    # We first need to add to LIBPATH_list the libraries provided by Julia
    append!(LIBPATH_list, [joinpath(Sys.BINDIR, Base.LIBDIR, "julia"), joinpath(Sys.BINDIR, Base.LIBDIR)])
    # From the list of our dependencies, generate a tuple of all the PATH and LIBPATH lists,
    # then append them to our own.
    foreach(p -> append!(PATH_list, p), (Zlib_jll.PATH_list, libpng_jll.PATH_list, JpegTurbo_jll.PATH_list, Libtiff_jll.PATH_list,))
    foreach(p -> append!(LIBPATH_list, p), (Zlib_jll.LIBPATH_list, libpng_jll.LIBPATH_list, JpegTurbo_jll.LIBPATH_list, Libtiff_jll.LIBPATH_list,))

    global libwand_path = normpath(joinpath(artifact_dir, libwand_splitpath...))

    # Manually `dlopen()` this right now so that future invocations
    # of `ccall` with its `SONAME` will find this path immediately.
    global libwand_handle = dlopen(libwand_path)
    push!(LIBPATH_list, dirname(libwand_path))

    # Filter out duplicate and empty entries in our PATH and LIBPATH entries
    filter!(!isempty, unique!(PATH_list))
    filter!(!isempty, unique!(LIBPATH_list))
    global PATH = join(PATH_list, ':')
    global LIBPATH = join(LIBPATH_list, ':')

    # Add each element of LIBPATH to our DL_LOAD_PATH (necessary on platforms
    # that don't honor our "already opened" trick)
    #for lp in LIBPATH_list
    #    push!(DL_LOAD_PATH, lp)
    #end
end  # __init__()

